import bpy
from bgl import *
from .. utils.blender_ui import dpi_factor
from . draw_px import draw_button_text, draw_point, draw_grid
from . help_info import draw_help
from .. utils.objects import current_selected_status
from .. preferences import preference, hud_y_offset


def draw_hud(self, context, xy_start, xy_scale):

    active_object, other_objects, other_object = current_selected_status()
    object = bpy.context.active_object

    if hud_y_offset():
        text_y_offset = -60
    else:
        text_y_offset = -40

    if object is not None:
        if context.active_object.mode != 'EDIT':
            xy = [xy_start[0] + xy_scale[0] * 20, xy_start[1] + xy_scale[1] * text_y_offset]
            draw_button_text(True, xy[0], xy[1], 'Cutter: {} ' .format(preference().BoxCutter_set_cutter_shape))

            xy = [xy_start[0] + xy_scale[0] * 122, xy_start[1] + xy_scale[1] * text_y_offset]
            if preference().BoxCutter_enable_grid:
                draw_button_text(True, xy[0], xy[1], 'Grid')

            if preference().BC_use_mirror:
                xy = [xy_start[0] + xy_scale[0] * 180, xy_start[1] + xy_scale[1] * text_y_offset]
                if preference().BoxCutter_mirror_axis_x and not preference().BoxCutter_mirror_axis_y:
                    draw_button_text(True, xy[0], xy[1], 'Mirror:  X')
                if preference().BoxCutter_mirror_axis_y and not preference().BoxCutter_mirror_axis_x:
                    draw_button_text(True, xy[0], xy[1], 'Mirror:  Y')
                if preference().BoxCutter_mirror_axis_x and preference().BoxCutter_mirror_axis_y:
                    draw_button_text(True, xy[0], xy[1], 'Mirror:  X, Y')

        if preference().BoxCutter_enable_grid:
            if preference().BoxCutter_type_of_grid == "CUSTOM":
                if preference().enable_grid_display:
                        draw_grid(self, context)
                draw_point(self, context)

    if preference().BoxCutter_enable_help:
        draw_help()
