import bpy
from bgl import *
from .. draw_px import draw_button_text
from ... preferences import preference
from ... utils.view_3d import scale
from ... utils.space_3d import point_to_2d


def draw_extending_box(self, context):

    if preference().BoxCutter_shape_moving:
        dx0 = self.mouse_path[0] + self.savedx
        dy0 = self.mouse_path[1] + self.savedy
    else:
        dx0 = self.first_mouse_x
        dy0 = self.first_mouse_y
    dx1 = self.mouse_path[0]
    dy1 = self.mouse_path[1]

    self.last_x_position = dx1
    self.last_y_position = dy1

    position = [[dx0, dy0], [dx0, dy1], [dx1, dy1], [dx1, dy0]]
    originmid = (dx0+dx1)/2, (dy0+dy1)/2
    self.position_2d = [position[0], position[1], position[2], position[3]]

    object = bpy.context.active_object
    if object is not None:
        if preference().BoxCutter_mirror_type == "3D":
            origin = point_to_2d(self, context, self.first_active.location[0], self.first_active.location[1], self.first_active.location[2])
        else:
            origin = point_to_2d(self, context, bpy.context.space_data.cursor_location[0], bpy.context.space_data.cursor_location[1], bpy.context.space_data.cursor_location[2])
    else:
        origin = point_to_2d(self, context, 0, 0, 0)

    glLineWidth(1)
    glColor4f(0, 0, 0, 0.75)
    glEnable(GL_BLEND)
    glEnable(GL_LINE_SMOOTH)

    self.rotated_mouse_path = self.position_2d[2]
    self.rotated_first_mouse = self.position_2d[0]

    glEnable(GL_LINE_STIPPLE)
    glBegin(GL_LINE_LOOP)
    if preference().BC_use_mirror:
        if preference().BoxCutter_mirror_axis_x and not preference().BoxCutter_mirror_axis_y:

            mirror_position_2d_x = [scale(origin, self.position_2d[0], "X"),
                                    scale(origin, self.position_2d[1], "X"),
                                    scale(origin, self.position_2d[2], "X"),
                                    scale(origin, self.position_2d[3], "X")]

            if self.position_2d[0][0] > mirror_position_2d_x[0][0] and self.position_2d[2][0] < origin[0] or self.position_2d[0][0] < mirror_position_2d_x[0][0] and self.position_2d[2][0] > origin[0]:
                self.clump_mirror = True
                glVertex3f(self.position_2d[0][0], self.position_2d[0][1], 0.0)
                glVertex3f(mirror_position_2d_x[0][0], mirror_position_2d_x[0][1], 0.0)
                glVertex3f(mirror_position_2d_x[1][0], mirror_position_2d_x[1][1], 0.0)
                glVertex3f(self.position_2d[1][0], self.position_2d[1][1], 0.0)
                # self.position_2d = [self.position_2d[0], mirror_position_2d_x[0], mirror_position_2d_x[1], self.position_2d[1]]

            else:
                basic_draw(self, context)

        elif preference().BoxCutter_mirror_axis_y and not preference().BoxCutter_mirror_axis_x:

            mirror_position_2d_y = [scale(origin, self.position_2d[0], "Y"),
                                    scale(origin, self.position_2d[1], "Y"),
                                    scale(origin, self.position_2d[2], "Y"),
                                    scale(origin, self.position_2d[3], "Y")]

            if self.position_2d[0][1] > mirror_position_2d_y[0][1] and self.position_2d[2][1] < origin[1] or self.position_2d[0][1] < mirror_position_2d_y[0][1] and self.position_2d[2][1] > origin[1]:
                self.clump_mirror = True

                glVertex3f(self.position_2d[0][0], self.position_2d[0][1], 0.0)
                glVertex3f(mirror_position_2d_y[0][0], mirror_position_2d_y[0][1], 0.0)
                glVertex3f(mirror_position_2d_y[3][0], mirror_position_2d_y[3][1], 0.0)
                glVertex3f(self.position_2d[3][0], self.position_2d[3][1], 0.0)
                # self.position_2d = [self.position_2d[0], mirror_position_2d_y[0], mirror_position_2d_y[3], self.position_2d[3]]

            else:
                basic_draw(self, context)

        else:
            basic_draw(self, context)
    else:
        basic_draw(self, context)

    glEnd()
    glDisable(GL_LINE_STIPPLE)

    glBegin(GL_QUADS)

    if self.mode == "SLICE":
        bgR, bgG, bgB, bgA = preference().BC_yellowbox_color
        glColor4f(bgR, bgG, bgB, bgA)
    elif self.mode == "CUT":
        bgR, bgG, bgB, bgA = preference().BC_redbox_color
        glColor4f(bgR, bgG, bgB, bgA)
    elif self.mode == "MAKE":
        bgR, bgG, bgB, bgA = preference().BC_graybox_color
        glColor4f(bgR, bgG, bgB, bgA)
    elif self.mode == "PANEL":
        bgR, bgG, bgB, bgA = preference().BC_purplebox_color
        glColor4f(bgR, bgG, bgB, bgA)
    elif self.mode == "KNIFE":
        bgR, bgG, bgB, bgA = preference().BC_bluebox_color
        glColor4f(bgR, bgG, bgB, bgA)

    if preference().BC_use_mirror:
        if preference().BoxCutter_mirror_axis_x and not preference().BoxCutter_mirror_axis_y:

            mirror_position_2d = [scale(origin, self.position_2d[0], "X"),
                                  scale(origin, self.position_2d[1], "X"),
                                  scale(origin, self.position_2d[2], "X"),
                                  scale(origin, self.position_2d[3], "X")]

            if self.position_2d[0][0] > mirror_position_2d[0][0] and self.position_2d[2][0] < origin[0] or self.position_2d[0][0] < mirror_position_2d[0][0] and self.position_2d[2][0] > origin[0]:
                self.clump_mirror = True
                glVertex3f(self.position_2d[0][0], self.position_2d[0][1], 0.0)
                glVertex3f(mirror_position_2d[0][0], mirror_position_2d[0][1], 0.0)
                glVertex3f(mirror_position_2d[1][0], mirror_position_2d[1][1], 0.0)
                glVertex3f(self.position_2d[1][0], self.position_2d[1][1], 0.0)
                self.position_2d = [self.position_2d[0], mirror_position_2d[0], mirror_position_2d[1], self.position_2d[1]]

            else:
                basic_draw(self, context)

        elif preference().BoxCutter_mirror_axis_y and not preference().BoxCutter_mirror_axis_x:

            mirror_position_2d = [scale(origin, self.position_2d[0], "Y"),
                                  scale(origin, self.position_2d[1], "Y"),
                                  scale(origin, self.position_2d[2], "Y"),
                                  scale(origin, self.position_2d[3], "Y")]

            if self.position_2d[0][1] > mirror_position_2d[0][1] and self.position_2d[2][1] < origin[1] or self.position_2d[0][1] < mirror_position_2d[0][1] and self.position_2d[2][1] > origin[1]:
                self.clump_mirror = True

                glVertex3f(self.position_2d[0][0], self.position_2d[0][1], 0.0)
                glVertex3f(mirror_position_2d[0][0], mirror_position_2d[0][1], 0.0)
                glVertex3f(mirror_position_2d[3][0], mirror_position_2d[3][1], 0.0)
                glVertex3f(self.position_2d[3][0], self.position_2d[3][1], 0.0)
                self.position_2d = [self.position_2d[0], mirror_position_2d[0], mirror_position_2d[3], self.position_2d[3]]

            else:
                basic_draw(self, context)

        else:
            basic_draw(self, context)
    else:
        basic_draw(self, context)

    if preference().BC_use_mirror:
        if not self.clump_mirror:
            if preference().BoxCutter_mirror_axis_x:
                    draw_mirror_x(self, context, origin)
            if preference().BoxCutter_mirror_axis_y:
                    draw_mirror_y(self, context, origin)
            if preference().BoxCutter_mirror_axis_x and preference().BoxCutter_mirror_axis_y:
                    draw_mirror_xy(self, context, origin)

    if self.clump_mirror:
        preference().boxcutter_mirror_clump = True
    else:
        preference().boxcutter_mirror_clump = False

    glEnd()
    glDisable(GL_BLEND)
    glDisable(GL_LINE_SMOOTH)


def basic_draw(self, context):
    self.clump_mirror = False
    glVertex2f(self.position_2d[0][0], self.position_2d[0][1])
    glVertex2f(self.position_2d[1][0], self.position_2d[1][1])
    glVertex2f(self.position_2d[2][0], self.position_2d[2][1])
    glVertex2f(self.position_2d[3][0], self.position_2d[3][1])


def draw_mirror_x(self, context, origin):

    glBegin(GL_QUADS)

    self.position_2d_mx = [scale(origin, self.position_2d[0], "X"),
                           scale(origin, self.position_2d[1], "X"),
                           scale(origin, self.position_2d[2], "X"),
                           scale(origin, self.position_2d[3], "X")]

    glVertex3f(self.position_2d_mx[0][0], self.position_2d_mx[0][1], 0.0)
    glVertex3f(self.position_2d_mx[1][0], self.position_2d_mx[1][1], 0.0)
    glVertex3f(self.position_2d_mx[2][0], self.position_2d_mx[2][1], 0.0)
    glVertex3f(self.position_2d_mx[3][0], self.position_2d_mx[3][1], 0.0)
    glEnd()


def draw_mirror_y(self, context, origin):

    glBegin(GL_QUADS)

    self.position_2d_my = [scale(origin, self.position_2d[0], "Y"),
                           scale(origin, self.position_2d[1], "Y"),
                           scale(origin, self.position_2d[2], "Y"),
                           scale(origin, self.position_2d[3], "Y")]

    glVertex3f(self.position_2d_my[0][0], self.position_2d_my[0][1], 0.0)
    glVertex3f(self.position_2d_my[1][0], self.position_2d_my[1][1], 0.0)
    glVertex3f(self.position_2d_my[2][0], self.position_2d_my[2][1], 0.0)
    glVertex3f(self.position_2d_my[3][0], self.position_2d_my[3][1], 0.0)
    glEnd()


def draw_mirror_xy(self, context, origin):

    glBegin(GL_QUADS)

    self.position_2d_mxy = [scale(origin, self.position_2d[0], "XY"),
                            scale(origin, self.position_2d[1], "XY"),
                            scale(origin, self.position_2d[2], "XY"),
                            scale(origin, self.position_2d[3], "XY")]

    glVertex3f(self.position_2d_mxy[0][0], self.position_2d_mxy[0][1], 0.0)
    glVertex3f(self.position_2d_mxy[1][0], self.position_2d_mxy[1][1], 0.0)
    glVertex3f(self.position_2d_mxy[2][0], self.position_2d_mxy[2][1], 0.0)
    glVertex3f(self.position_2d_mxy[3][0], self.position_2d_mxy[3][1], 0.0)
    glEnd()
