import bpy
from bgl import *
import bpy_extras.view3d_utils
from .. utils.blender_ui import dpi_factor, view_3d_tools_panel_overlay_width
from .. preferences import BC_indicator_color1, BC_indicator_color2, BC_indicator_size, BC_indicator_y_position, BC_indicator_x_position, preference
from . logo_button import logo_boxcutter_button


def draw_logo_boxcutter():

    if preference().BC_switch:
        if preference().BoxCutter_set_bc_mode == "MESHMAKER":
            color = (0.35, 1, 0.29, 0.53)
        else:
            if preference().workflow == "DESTRUCTIVE":
                color = BC_indicator_color1()[:]
            else:
                color = BC_indicator_color2()[:]
    else:
        color = preference().BC_indicator_color_off

    rw = bpy.context.region.width - view_3d_tools_panel_overlay_width(bpy.context.area, "right")
    rh = bpy.context.region.height - 50
    d = BC_indicator_size()
    x = BC_indicator_x_position()
    y = BC_indicator_y_position()

    bgR = color[0]
    bgG = color[1]
    bgB = color[2]
    bgA = color[3]

    glEnable(GL_BLEND)
    glEnable(GL_LINE_SMOOTH)

    glColor4f(bgR, bgG, bgB, bgA)

    glBegin(GL_TRIANGLE_FAN)
    glVertex2f(rw + 0*d + x, rh + (0*d + y))
    glVertex2f(rw + 4*d + x, rh + (0*d + y))
    glVertex2f(rw + 4*d + x, rh + (1*d + y))
    glVertex2f(rw + 1*d + x, rh + (1*d + y))
    glVertex2f(rw + 1*d + x, rh + (4*d + y))
    glVertex2f(rw + 0*d + x, rh + (4*d + y))
    glEnd()

    glBegin(GL_TRIANGLE_FAN)
    glVertex2f(rw + 10*d + x, rh + (0*d + y))
    glVertex2f(rw + 10*d + x, rh + (4*d + y))
    glVertex2f(rw + 9*d + x, rh + (4*d + y))
    glVertex2f(rw + 9*d + x, rh + (1*d + y))
    glVertex2f(rw + 6*d + x, rh + (1*d + y))
    glVertex2f(rw + 6*d + x, rh + (0*d + y))
    glEnd()

    glBegin(GL_TRIANGLE_FAN)
    glVertex2f(rw + 0*d + x, rh + (10*d + y))
    glVertex2f(rw + 0*d + x, rh + (6*d + y))
    glVertex2f(rw + 1*d + x, rh + (6*d + y))
    glVertex2f(rw + 1*d + x, rh + (9*d + y))
    glVertex2f(rw + 4*d + x, rh + (9*d + y))
    glVertex2f(rw + 4*d + x, rh + (10*d + y))
    glEnd()

    glBegin(GL_TRIANGLE_FAN)
    glVertex2f(rw + 9*d + x, rh + (9*d + y))
    glVertex2f(rw + 9*d + x, rh + (6*d + y))
    glVertex2f(rw + 10*d + x, rh + (6*d + y))
    glVertex2f(rw + 10*d + x, rh + (10*d + y))
    glVertex2f(rw + 6*d + x, rh + (10*d + y))
    glVertex2f(rw + 6*d + x, rh + (9*d + y))
    glEnd()

    glBegin(GL_TRIANGLE_FAN)
    glVertex2f(rw + 2*d + x, rh + (2*d + y))
    glVertex2f(rw + 2*d + x, rh + (8*d + y))
    glVertex2f(rw + 8*d + x, rh + (2*d + y))
    glEnd()

    glBegin(GL_TRIANGLE_FAN)
    glVertex2f(rw + 3*d + x, rh + (7*d + y))
    glVertex2f(rw + 7*d + x, rh + (7*d + y))
    glVertex2f(rw + 6*d + x, rh + (6*d + y))
    glVertex2f(rw + 4*d + x, rh + (6*d + y))
    glEnd()

    glBegin(GL_TRIANGLE_FAN)
    glVertex2f(rw + 6*d + x, rh + (6*d + y))
    glVertex2f(rw + 7*d + x, rh + (7*d + y))
    glVertex2f(rw + 7*d + x, rh + (3*d + y))
    glVertex2f(rw + 6*d + x, rh + (4*d + y))
    glEnd()

    glDisable(GL_BLEND)
    glDisable(GL_LINE_SMOOTH)
