import bpy

class GrabMouseLocation(bpy.types.Operator):
    bl_idname = "wm.grab_mouse_position"
    bl_label = "Grab Mouse location"

    def execute(self, context):
        bpy.types.WindowManager.mouse_pos = [self.x, self.y]
        bpy.types.WindowManager.left_click = self.left_click
        bpy.types.WindowManager.right_click = self.right_click
        return {'FINISHED'}

    def invoke(self, context, event):
        self.x = event.mouse_region_x
        self.y = event.mouse_region_y
        self.left_click = event.type == "LEFTMOUSE" and event.value == "PRESS"
        self.right_click = event.type == "RIGHTMOUSE" and event.value == "PRESS"
        return self.execute(context)
