import bpy
import os
from bpy.props import *
from ... preferences import preference

class BoxCutterCutterShapeBox(bpy.types.Operator):
    """
    BOX Drawing shape
    Ctrl + LMB drag to draw box.

    """
    bl_idname = "boxcutter.set_box_shape"
    bl_label = "Set Box Shape"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        preference().BoxCutter_set_cutter_shape = "BOX"
        return {'FINISHED'}

class BoxCutterCutterShapeCircle(bpy.types.Operator):
    """
    CIRCLE Drawing shape
    Ctrl + LMB drag to draw center circle.

    """
    bl_idname = "boxcutter.set_circle_shape"
    bl_label = "Set Circle Shape"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        preference().BoxCutter_set_cutter_shape = "CIRCLE"
        return {'FINISHED'}

class BoxCutterCutterShapeNgon(bpy.types.Operator):
    """
    NGON Drawing shape
    Ctrl + LMB drag to start. Then ctrl + LMB to add points.

    """
    bl_idname = "boxcutter.set_ngon_shape"
    bl_label = "Set Ngon Shape"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        preference().BoxCutter_set_cutter_shape = "NGON"
        return {'FINISHED'}
