import bpy
from bpy.props import *
from bpy.types import (Panel,
                       Operator,
                       AddonPreferences,
                       PropertyGroup,
                       )
from .. preferences import preference
from .. utils.addons import addon_exists


def boxcutter_enable_hops():
    return preference().BoxCutter_enable_hops


class BoxCutterPanel(bpy.types.Panel):
    bl_label = "Box Cutter"
    bl_category = "HardOps"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'TOOLS'

    # enable_hops = BoolProperty(name = "Enable Hops", default=True)

    def draw(self, context):
        layout = self.layout
        col = layout.column()
        col.separator()
        col.operator("boxcutter.draw_boolean_layout", text="Start BoxCutter")
        col.separator()
        col.operator("screen.userpref_show", text="Addon Options")
        col.separator()
        colrow = col.row(align=True)
        if addon_exists("HOps") or any(name in bpy.context.user_preferences.addons for name in ('HOps', 'HOps-master', 'HardOps', 'hops', 'hardops')):
            col.prop(preference(), "BoxCutter_enable_hops", text="HardOps Connection")
        elif preference().BoxCutter_enable_hops:
            preference().BoxCutter_enable_hops = False
        col.prop(preference(), "grey_box_select", text="Grey Box Select")
        col.prop(preference(), "BoxCutter_show_wires", text="Show Wire In Cut Mode")
        col.separator()
        col.prop(preference(), "BoxCutter_circle_vert_count", text="Circle Vert")
        col.prop(preference(), "BoxCutter_curve_vert_count", text="Curve Vert")
        col.prop(preference(), "BoxCutter_bevel_segments", text="Bevel Segments")
        col.prop(preference(), "BoxCutter_enable_grid", text="Grid")
        if preference().BoxCutter_enable_grid:
            col.prop(preference(), "BoxCutter_grid_spaceing", text="Spacing")
        col.label("Mirror:")
        colrow = col.row(align=True)
        colrow.prop(preference(), "BoxCutter_mirror_axis_x", text="X", toggle=True)
        colrow.prop(preference(), "BoxCutter_mirror_axis_y", text="Y", toggle=True)
        col.separator()
        col.prop(preference(), "BoxCutter_enable_help", text="Display Help")
