import bpy
import textwrap


def dpi_factor():
    return dpi() / 72


def dpi():
    systemPreferences = bpy.context.user_preferences.system
    retinaFactor = getattr(systemPreferences, "pixel_size", 1)
    return int(systemPreferences.dpi * retinaFactor)


def view_3d_tools_panel_overlay_width(area, placement):
    use_region_overlap = bpy.context.user_preferences.system.use_region_overlap

    n = 0
    t = 0

    if placement == "left":
        if use_region_overlap:
            for region in area.regions:
                if region.type == "UI":
                    if region.x < bpy.context.region.width/3:
                        n = region.width
                if region.type == "TOOLS":
                    if region.x < bpy.context.region.width/3:
                        t = region.width

    if placement == "right":
        if use_region_overlap:
            for region in area.regions:
                if region.type == "UI":
                    if region.x > bpy.context.region.width/3:
                        n = region.width
                if region.type == "TOOLS":
                    if region.x > bpy.context.region.width/3:
                        t = region.width

    return n + t


def write_text(layout, text, width=30, icon="NONE"):
    col = layout.column(align=True)
    col.scale_y = 0.85
    prefix = " "
    for paragraph in text.split("\n"):
        for line in textwrap.wrap(paragraph, width):
            col.label(prefix + line, icon=icon)
            if icon != "NONE": prefix = "     "
            icon = "NONE"


def region_dimensions():
    height = bpy.context.region.height
    width = bpy.context.region.width

    return height, width
