import bpy
from .. graphic.draw_operators.shape import Shape
from .. preferences import BoxCutter_enable_hops

live = list()

class duplicate_modifier:
    modifier = None

    def __init__(self, duplicate, modifier):
        self.modifier = duplicate.modifiers.new(name=modifier.name, type=modifier.type)
        getattr(self, modifier.type.lower())(modifier)

    def armature(self, modifier):
        self.modifier.object = modifier.object
        self.modifier.use_deform_preserve_volume = modifier.use_deform_preserve_volume
        self.modifier.use_vertex_groups = modifier.use_vertex_groups
        self.modifier.use_bone_envelopes = modifier.use_bone_envelopes
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.use_multi_modifier = modifier.use_multi_modifier

    def array(self, modifier):
        self.modifier.fit_type = modifier.fit_type
        self.modifier.count = modifier.count
        self.modifier.fit_length = modifier.fit_length
        self.modifier.curve = modifier.curve
        self.modifier.use_constant_offset = modifier.use_constant_offset
        self.modifier.constant_offset_displace = modifier.constant_offset_displace
        self.modifier.use_merge_vertices = modifier.use_merge_vertices
        self.modifier.use_merge_vertices_cap = modifier.use_merge_vertices_cap
        self.modifier.merge_threshold = modifier.merge_threshold
        self.modifier.use_relative_offset = modifier.use_relative_offset
        self.modifier.relative_offset_displace = modifier.relative_offset_displace
        self.modifier.use_object_offset = modifier.use_object_offset
        self.modifier.offset_object = modifier.offset_object
        self.modifier.start_cap = modifier.start_cap
        self.modifier.end_cap = modifier.end_cap

    def bevel(self, modifier):
        self.modifier.width = modifier.width
        self.modifier.segments = modifier.segments
        self.modifier.profile = modifier.profile
        self.modifier.material = modifier.material
        self.modifier.use_only_vertices = modifier.use_only_vertices
        self.modifier.use_clamp_overlap = modifier.use_clamp_overlap
        self.modifier.loop_slide = modifier.loop_slide
        self.modifier.limit_method = modifier.limit_method
        self.modifier.angle_limit = modifier.angle_limit
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.offset_type = modifier.offset_type

    def boolean(self, modifier):
        self.modifier.operation = modifier.operation
        self.modifier.object = modifier.object
        if hasattr(modifier, 'solver'):
            self.modifier.solver = modifier.solver
        self.modifier.double_threshold = modifier.double_threshold
        self.modifier.debug_options = modifier.debug_options

    def build(self, modifier):
        self.modifier.frame_start = modifier.frame_start
        self.modifier.frame_duration = modifier.frame_duration
        self.modifier.use_reverse = modifier.use_reverse
        self.modifier.use_random_order = modifier.use_random_order
        self.modifier.seed = modifier.seed

    def mesh_cache(self, modifier):
        self.modifier.cache_format = modifier.cache_format
        self.modifier.filepath = modifier.filepath
        self.modifier.sub_object = modifier.sub_object
        self.modifier.factor = modifier.factor
        self.modifier.deform_mode = modifier.deform_mode
        self.modifier.interpolation = modifier.interpolation
        self.modifier.time_mode = modifier.time_mode
        self.modifier.play_mode = modifier.play_mode
        self.modifier.frame_start = modifier.frame_start
        self.modifier.frame_scale = modifier.frame_scale
        self.modifier.eval_frame = modifier.eval_frame
        self.modifier.eval_time = modifier.eval_time
        self.modifier.eval_factor = modifier.eval_factor
        self.modifier.forward_axis = modifier.forward_axis
        self.modifier.up_axis = modifier.up_axis
        self.modifier.flip_axis = modifier.flip_axis

    def mesh_sequence_cache(self, modifier):
        self.modifier.cache_file = modifier.cache_file
        self.modifier.object_path = modifier.object_path
        self.modifier.read_data = modifier.read_data

    def cast(self, modifier):
        self.modifier.cast_type = modifier.cast_type
        self.modifier.use_x = modifier.use_x
        self.modifier.use_y = modifier.use_y
        self.modifier.use_z = modifier.use_z
        self.modifier.factor = modifier.factor
        self.modifier.radius = modifier.radius
        self.modifier.size = modifier.size
        self.modifier.use_radius_as_size = modifier.use_radius_as_size
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.object = modifier.object
        self.modifier.use_transform = modifier.use_transform

    def cloth(self, modifier):
        pass

    def collision(self, modifier):
        pass

    def curve(self, modifier):
        self.modifier.object = modifier.object
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.deform_axis = modifier.deform_axis

    def decimate(self, modifier):
        self.modifier.decimate_type = modifier.decimate_type
        self.modifier.ratio = modifier.ratio
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.vertex_group_factor = modifier.vertex_group_factor
        self.modifier.use_collapse_triangulate = modifier.use_collapse_triangulate
        self.modifier.use_symmetry = modifier.use_symmetry
        self.modifier.symmetry_axis = modifier.symmetry_axis
        self.modifier.iterations = modifier.iterations
        self.modifier.angle_limit = modifier.angle_limit
        self.modifier.use_dissolve_boundaries = modifier.use_dissolve_boundaries
        self.modifier.delimit = modifier.delimit

    def displace(self, modifier):
        self.modifier.texture = modifier.texture
        self.modifier.direction = modifier.direction
        self.modifier.space = modifier.space
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.texture_coords = modifier.texture_coords
        self.modifier.texture_coords_object = modifier.texture_coords_object
        self.modifier.uv_layer = modifier.uv_layer
        self.modifier.mid_level = modifier.mid_level
        self.modifier.strength = modifier.strength

    def dynamic_paint(self, modifier):
        pass

    def edge_split(self, modifier):
        self.modifier.use_edge_angle = modifier.use_edge_angle
        self.modifier.split_angle = modifier.split_angle
        self.modifier.use_edge_sharp = modifier.use_edge_sharp

    def explode(self, modifier):
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.protect = modifier.protect
        self.modifier.particle_uv = modifier.particle_uv
        self.modifier.use_edge_cut = modifier.use_edge_cut
        self.modifier.show_unborn = modifier.show_unborn
        self.modifier.show_alive = modifier.show_alive
        self.modifier.show_dead = modifier.show_dead
        self.modifier.use_size = modifier.use_size

    def fluid_simulation(self, modifier):
        pass

    def hook(self, modifier):
        self.modifier.object = modifier.object
        self.modifier.subtarget = modifier.subtarget
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.falloff_radius = modifier.falloff_radius
        self.modifier.strength = modifier.strength
        self.modifier.falloff_type = modifier.falloff_type
        self.modifier.falloff_curve = modifier.falloff_curve
        self.modifier.use_falloff_uniform = modifier.use_falloff_uniform

    def laplaciandeform(self, modifier):
        self.modifier.iterations = modifier.iterations
        self.modifier.vertex_group = modifier.vertex_group

    def laplaciansmooth(self, modifier):
        self.modifier.iterations = modifier.iterations
        self.modifier.use_x = modifier.use_x
        self.modifier.use_y = modifier.use_y
        self.modifier.use_z = modifier.use_z
        self.modifier.lambda_factor = modifier.lambda_factor
        self.modifier.lambda_border = modifier.lambda_border
        self.modifier.use_volume_preserve = modifier.use_volume_preserve
        self.modifier.use_normalized = modifier.use_normalized
        self.modifier.vertex_group = modifier.vertex_group

    def lattice(self, modifier):
        self.modifier.object = modifier.object
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.strength = modifier.strength

    def mask(self, modifier):
        self.modifier.mode = modifier.mode
        self.modifier.armature = modifier.armature
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group

    def mesh_deform(self, modifier):
        self.modifier.object = modifier.object
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.precision = modifier.precision
        self.modifier.use_dynamic_bind = modifier.use_dynamic_bind

    def mirror(self, modifier):
        self.modifier.use_x = modifier.use_x
        self.modifier.use_y = modifier.use_y
        self.modifier.use_z = modifier.use_z
        self.modifier.use_mirror_merge = modifier.use_mirror_merge
        self.modifier.use_clip = modifier.use_clip
        self.modifier.use_mirror_vertex_groups = modifier.use_mirror_vertex_groups
        self.modifier.use_mirror_u = modifier.use_mirror_u
        self.modifier.use_mirror_v = modifier.use_mirror_v
        self.modifier.mirror_offset_u = modifier.mirror_offset_u
        self.modifier.mirror_offset_v = modifier.mirror_offset_v
        self.modifier.merge_threshold = modifier.merge_threshold
        self.modifier.mirror_object = modifier.mirror_object

    def multires(self, modifier):
        self.modifier.subdivision_type = modifier.subdivision_type
        self.modifier.levels = modifier.levels
        self.modifier.sculpt_levels = modifier.sculpt_levels
        self.modifier.render_levels = modifier.render_levels
        self.modifier.use_subsurf_uv = modifier.use_subsurf_uv
        self.modifier.show_only_control_edges = modifier.show_only_control_edges
        self.modifier.filepath = modifier.filepath

    def ocean(self, modifier):
        self.modifier.geometry_mode = modifier.geometry_mode
        self.modifier.repeat_x = modifier.repeat_x
        self.modifier.repeat_y = modifier.repeat_y
        self.modifier.time = modifier.time
        self.modifier.depth = modifier.depth
        self.modifier.random_seed = modifier.random_seed
        self.modifier.resolution = modifier.resolution
        self.modifier.size = modifier.size
        self.modifier.spatial_size = modifier.spatial_size
        self.modifier.choppiness = modifier.choppiness
        self.modifier.wave_scale = modifier.wave_scale
        self.modifier.wave_scale_min = modifier.wave_scale_min
        self.modifier.wind_velocity = modifier.wind_velocity
        self.modifier.wave_alignment = modifier.wave_alignment
        self.modifier.wave_direction = modifier.wave_direction
        self.modifier.damping = modifier.damping
        self.modifier.use_normals = modifier.use_normals
        self.modifier.use_foam = modifier.use_foam
        self.modifier.foam_coverage = modifier.foam_coverage
        self.modifier.foam_layer_name = modifier.foam_layer_name
        self.modifier.frame_start = modifier.frame_start
        self.modifier.frame_end = modifier.frame_end
        self.modifier.filepath = modifier.filepath
        self.modifier.bake_foam_fade = modifier.bake_foam_fade

    def particle_instance(self, modifier):
        self.modifier.object = modifier.object
        self.modifier.particle_system_index = modifier.particle_system_index
        self.modifier.use_normal = modifier.use_normal
        self.modifier.use_children = modifier.use_children
        self.modifier.use_size = modifier.use_size
        self.modifier.show_alive = modifier.show_alive
        self.modifier.show_unborn = modifier.show_unborn
        self.modifier.show_dead = modifier.show_dead
        self.modifier.use_path = modifier.use_path
        self.modifier.axis = modifier.axis
        self.modifier.use_preserve_shape = modifier.use_preserve_shape
        self.modifier.position = modifier.position
        self.modifier.random_position = modifier.random_position

    def particle_system(self, modifier):
        pass

    def screw(self, modifier):
        self.modifier.axis = modifier.axis
        self.modifier.object = modifier.object
        self.modifier.angle = modifier.angle
        self.modifier.steps = modifier.steps
        self.modifier.render_steps = modifier.render_steps
        self.modifier.use_smooth_shade = modifier.use_smooth_shade
        self.modifier.use_merge_vertices = modifier.use_merge_vertices
        self.modifier.merge_threshold = modifier.merge_threshold
        self.modifier.screw_offset = modifier.screw_offset
        self.modifier.use_object_screw_offset = modifier.use_object_screw_offset
        self.modifier.use_normal_calculate = modifier.use_normal_calculate
        self.modifier.use_normal_flip = modifier.use_normal_flip
        self.modifier.iterations = modifier.iterations
        self.modifier.use_stretch_u = modifier.use_stretch_u
        self.modifier.use_stretch_v = modifier.use_stretch_v

    def shrinkwrap(self, modifier):
        self.modifier.target = modifier.target
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.offset = modifier.offset
        self.modifier.wrap_method = modifier.wrap_method
        self.modifier.subsurf_levels = modifier.subsurf_levels
        self.modifier.project_limit = modifier.project_limit
        self.modifier.use_project_x = modifier.use_project_x
        self.modifier.use_project_y = modifier.use_project_y
        self.modifier.use_project_z = modifier.use_project_z
        self.modifier.use_negative_direction = modifier.use_negative_direction
        self.modifier.use_positive_direction = modifier.use_positive_direction
        self.modifier.cull_face = modifier.cull_face
        self.modifier.auxiliary_target = modifier.auxiliary_target
        self.modifier.use_keep_above_surface = modifier.use_keep_above_surface

    def simple_deform(self, modifier):
        self.modifier.deform_method = modifier.deform_method
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.origin = modifier.origin
        self.modifier.lock_x = modifier.lock_x
        self.modifier.lock_y = modifier.lock_y
        self.modifier.factor = modifier.factor
        self.modifier.angle = modifier.angle
        self.modifier.limits = modifier.limits

    def smoke(self, modifier):
        pass

    def smooth(self, modifier):
        self.modifier.use_x = modifier.use_x
        self.modifier.use_y = modifier.use_y
        self.modifier.use_z = modifier.use_z
        self.modifier.factor = modifier.factor
        self.modifier.iterations = modifier.iterations
        self.modifier.vertex_group = modifier.vertex_group

    def soft_body(self, modifier):
        pass

    def solidify(self, modifier):
        self.modifier.thickness = modifier.thickness
        self.modifier.thickness_clamp = modifier.thickness_clamp
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.thickness_vertex_group = modifier.thickness_vertex_group
        self.modifier.edge_crease_inner = modifier.edge_crease_inner
        self.modifier.edge_crease_outer = modifier.edge_crease_outer
        self.modifier.edge_crease_rim = modifier.edge_crease_rim
        self.modifier.offset = modifier.offset
        self.modifier.use_flip_normals = modifier.use_flip_normals
        self.modifier.use_even_offset = modifier.use_even_offset
        self.modifier.use_quality_normals = modifier.use_quality_normals
        self.modifier.use_rim = modifier.use_rim
        self.modifier.use_rim_only = modifier.use_rim_only
        self.modifier.material_offset = modifier.material_offset
        self.modifier.material_offset_rim = modifier.material_offset_rim

    def subsurf(self, modifier):
        self.modifier.subdivision_type = modifier.subdivision_type
        self.modifier.levels = modifier.levels
        self.modifier.render_levels = modifier.render_levels
        self.modifier.levels = modifier.levels
        self.modifier.render_levels = modifier.render_levels
        self.modifier.use_subsurf_uv = modifier.use_subsurf_uv
        self.modifier.show_only_control_edges = modifier.show_only_control_edges
        self.modifier.use_opensubdiv = modifier.use_opensubdiv

    def surface(self, modifier):
        pass

    def surface_deform(self, modifier):
        self.modifier.target = modifier.target
        self.modifier.falloff = modifier.falloff

    def uv_project(self, modifier):
        self.modifier.image = modifier.image
        self.modifier.uv_layer = modifier.uv_layer
        self.modifier.use_image_override = modifier.use_image_override
        self.modifier.projector_count = modifier.projector_count
        self.modifier.aspect_x = modifier.aspect_x
        self.modifier.aspect_y = modifier.aspect_y
        self.modifier.scale_x = modifier.scale_x
        self.modifier.scale_y = modifier.scale_y

    def warp(self, modifier):
        self.modifier.object_from = modifier.object_from
        self.modifier.use_volume_preserve = modifier.use_volume_preserve
        self.modifier.object_to = modifier.object_to
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.strength = modifier.strength
        self.modifier.falloff_radius = modifier.falloff_radius
        self.modifier.falloff_type = modifier.falloff_type
        self.modifier.falloff_curve = modifier.falloff_curve
        self.modifier.texture = modifier.texture
        self.modifier.texture_coords = modifier.texture_coords
        self.modifier.texture_coords_object = modifier.texture_coords_object
        self.modifier.uv_layer = modifier.uv_layer
        self.modifier.use_x = modifier.use_x
        self.modifier.use_y = modifier.use_y
        self.modifier.use_cyclic = modifier.use_cyclic
        self.modifier.use_normal = modifier.use_normal
        self.modifier.use_normal_x = modifier.use_normal_x
        self.modifier.use_normal_y = modifier.use_normal_y
        self.modifier.use_normal_z = modifier.use_normal_z
        self.modifier.time_offset = modifier.time_offset
        self.modifier.lifetime = modifier.lifetime
        self.modifier.damping_time = modifier.damping_time
        self.modifier.start_position_x = modifier.start_position_x
        self.modifier.start_position_y = modifier.start_position_y
        self.modifier.falloff_radius = modifier.falloff_radius
        self.modifier.start_position_object = modifier.start_position_object
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.texture = modifier.texture
        self.modifier.texture_coords = modifier.texture_coords
        self.modifier.uv_layer = modifier.uv_layer
        self.modifier.texture_coords_object = modifier.texture_coords_object
        self.modifier.speed = modifier.speed
        self.modifier.height = modifier.height
        self.modifier.width = modifier.width
        self.modifier.narrowness = modifier.narrowness

    def remesh(self, modifier):
        self.modifier.mode = modifier.mode
        self.modifier.octree_depth = modifier.octree_depth
        self.modifier.scale = modifier.scale
        self.modifier.sharpness = modifier.sharpness
        self.modifier.use_smooth_shade = modifier.use_smooth_shade
        self.modifier.use_remove_disconnected = modifier.use_remove_disconnected
        self.modifier.threshold = modifier.threshold

    def vertex_weight_edit(self, modifier):
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.default_weight = modifier.default_weight
        self.modifier.use_add = modifier.use_add
        self.modifier.add_threshold = modifier.add_threshold
        self.modifier.use_remove = modifier.use_remove
        self.modifier.remove_threshold = modifier.remove_threshold
        self.modifier.falloff_type = modifier.falloff_type
        self.modifier.map_curve = modifier.map_curve
        self.modifier.mask_constant = modifier.mask_constant
        self.modifier.mask_vertex_group = modifier.mask_vertex_group
        self.modifier.mask_texture = modifier.mask_texture
        self.modifier.mask_tex_mapping = modifier.mask_tex_mapping
        self.modifier.mask_tex_map_object = modifier.mask_tex_map_object
        self.modifier.mask_tex_uv_layer = modifier.mask_tex_uv_layer

    def vertex_weight_mix(self, modifier):
        self.modifier.vertex_group_a = modifier.vertex_group_a
        self.modifier.default_weight_a = modifier.default_weight_a
        self.modifier.mix_mode = modifier.mix_mode
        self.modifier.vertex_group_b = modifier.vertex_group_b
        self.modifier.default_weight_b = modifier.default_weight_b
        self.modifier.mix_set = modifier.mix_set
        self.modifier.mask_constant = modifier.mask_constant
        self.modifier.mask_vertex_group = modifier.mask_vertex_group
        self.modifier.mask_texture = modifier.mask_texture
        self.modifier.mask_tex_mapping = modifier.mask_tex_mapping
        self.modifier.mask_tex_use_channel = modifier.mask_tex_use_channel
        self.modifier.mask_tex_map_object = modifier.mask_tex_map_object
        self.modifier.mask_tex_uv_layer = modifier.mask_tex_uv_layer

    def vertex_weight_proximity(self, modifier):
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.target = modifier.target
        self.modifier.proximity_mode = modifier.proximity_mode
        self.modifier.proximity_geometry = modifier.proximity_geometry
        self.modifier.min_dist = modifier.min_dist
        self.modifier.max_dist = modifier.max_dist
        self.modifier.falloff_type = modifier.falloff_type
        self.modifier.mask_constant = modifier.mask_constant
        self.modifier.mask_vertex_group = modifier.mask_vertex_group
        self.modifier.mask_texture = modifier.mask_texture
        self.modifier.mask_tex_mapping = modifier.mask_tex_mapping
        self.modifier.mask_tex_use_channel = modifier.mask_tex_use_channel
        self.modifier.mask_tex_map_object = modifier.mask_tex_map_object
        self.modifier.mask_tex_uv_layer = modifier.mask_tex_uv_layer

    def skin(self, modifier):
        self.modifier.branch_smoothing = modifier.branch_smoothing
        self.modifier.use_smooth_shade = modifier.use_smooth_shade
        self.modifier.use_x_symmetry = modifier.use_x_symmetry
        self.modifier.use_y_symmetry = modifier.use_y_symmetry
        self.modifier.use_z_symmetry = modifier.use_z_symmetry

    def triangulate(self, modifier):
        self.modifier.quad_method = modifier.quad_method
        self.modifier.ngon_method = modifier.ngon_method

    def uv_warp(self, modifier):
        self.modifier.center = modifier.center
        self.modifier.axis_u = modifier.axis_u
        self.modifier.axis_v = modifier.axis_v
        self.modifier.object_from = modifier.object_from
        self.modifier.object_to = modifier.object_to
        self.modifier.bone_from = modifier.bone_from
        self.modifier.bone_to = modifier.bone_to
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.uv_layer = modifier.uv_layer

    def wireframe(self, modifier):
        self.modifier.thickness = modifier.thickness
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.thickness_vertex_group = modifier.thickness_vertex_group
        self.modifier.use_crease = modifier.use_crease
        self.modifier.crease_weight = modifier.crease_weight
        self.modifier.offset = modifier.offset
        self.modifier.use_even_offset = modifier.use_even_offset
        self.modifier.use_relative_offset = modifier.use_relative_offset
        self.modifier.use_boundary = modifier.use_boundary
        self.modifier.use_replace = modifier.use_replace
        self.modifier.material_offset = modifier.material_offset

    def data_transfer(self, modifier):
        self.modifier.object = modifier.object
        self.modifier.use_object_transform = modifier.use_object_transform
        self.modifier.use_vert_data = modifier.use_vert_data
        self.modifier.vert_mapping = modifier.vert_mapping
        self.modifier.data_types_verts = modifier.data_types_verts
        self.modifier.layers_vgroup_select_src = modifier.layers_vgroup_select_src
        self.modifier.layers_vgroup_select_dst = modifier.layers_vgroup_select_dst
        self.modifier.use_edge_data = modifier.use_edge_data
        self.modifier.edge_mapping = modifier.edge_mapping
        self.modifier.data_types_edges = modifier.data_types_edges
        self.modifier.use_loop_data = modifier.use_loop_data
        self.modifier.loop_mapping = modifier.loop_mapping
        self.modifier.data_types_loops = modifier.data_types_loops
        self.modifier.layers_vcol_select_src = modifier.layers_vcol_select_src
        self.modifier.layers_vcol_select_dst = modifier.layers_vcol_select_dst
        self.modifier.layers_uv_select_src = modifier.layers_uv_select_src
        self.modifier.layers_uv_select_dst = modifier.layers_uv_select_dst
        self.modifier.islands_precision = modifier.islands_precision
        self.modifier.use_poly_data = modifier.use_poly_data
        self.modifier.poly_mapping = modifier.poly_mapping
        self.modifier.data_types_polys = modifier.data_types_polys
        self.modifier.max_distance = modifier.max_distance
        self.modifier.use_max_distance = modifier.use_max_distance
        self.modifier.ray_radius = modifier.ray_radius
        self.modifier.mix_mode = modifier.mix_mode
        self.modifier.mix_factor = modifier.mix_factor
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group

    def normal_edit(self, modifier):
        self.modifier.mode = modifier.mode
        self.modifier.target = modifier.target
        self.modifier.offset = modifier.offset
        self.modifier.use_direction_parallel = modifier.use_direction_parallel
        self.modifier.mix_mode = modifier.mix_mode
        self.modifier.mix_factor = modifier.mix_factor
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.mix_limit = modifier.mix_limit

    def corrective_smooth(self, modifier):
        self.modifier.factor = modifier.factor
        self.modifier.iterations = modifier.iterations
        self.modifier.smooth_type = modifier.smooth_type
        self.modifier.vertex_group = modifier.vertex_group
        self.modifier.invert_vertex_group = modifier.invert_vertex_group
        self.modifier.use_only_smooth = modifier.use_only_smooth
        self.modifier.use_pin_boundary = modifier.use_pin_boundary
        self.modifier.rest_source = modifier.rest_source


def apply_modifiers(object, type='ALL', modifier=None):
    global live

    if object.type == 'MESH':
        modifiers = []
        for mod in object.modifiers:
            if type != 'ALL' and mod.type == type:
                if not modifier:
                    if mod.type == 'BOOLEAN':
                        if mod.object and mod.object.name not in live:
                            if hasattr(mod.object, 'kitops') and not mod.object.kitops.insert:
                                if BoxCutter_enable_hops() and mod.object and not mod.object.hops.status == 'BOOLSHAPE2':
                                    modifiers.append(mod)
                                else:
                                    modifiers.append(mod)
                            else:
                                if BoxCutter_enable_hops() and mod.object and not mod.object.hops.status == 'BOOLSHAPE2':
                                    modifiers.append(mod)
                                else:
                                    modifiers.append(mod)
                    else:
                        modifiers.append(mod)
                elif modifier == mod:
                    if mod.type == 'BOOLEAN':
                        if mod.object and mod.object.name not in live:
                            if hasattr(mod.object, 'kitops') and not mod.object.kitops.insert:
                                if BoxCutter_enable_hops() and mod.object and not mod.object.hops.status == 'BOOLSHAPE2':
                                    modifiers.append(mod)
                                else:
                                    modifiers.append(mod)
                            else:
                                if BoxCutter_enable_hops() and modifier.object and not modifier.object.hops.status == 'BOOLSHAPE2':
                                    modifiers.append(mod)
                                else:
                                    modifiers.append(mod)
                    else:
                        modifiers.append(mod)
            # removing all
            elif not modifier:
                modifiers.append(mod)
            elif modifier == mod:
                modifiers.append(mod)

        if modifiers:
            duplicate = object.copy()
            duplicate.data = object.data.copy()

            duplicate.modifiers.clear()

            for modifier in modifiers:
                duplicate_modifier(duplicate, modifier)

            for modifier in modifiers:
                for mod in object.modifiers:
                    if mod == modifier:
                        object.modifiers.remove(modifier)

            del modifiers

            duplicate.data = duplicate.to_mesh(bpy.context.scene, apply_modifiers=True, settings='PREVIEW', calc_tessface=False)

            old_data = bpy.data.meshes[object.data.name]
            name = old_data.name

            object.data = duplicate.data
            object.data.name = name

            duplicate.data = old_data
            try: bpy.data.meshes.remove(duplicate.data)
            except: pass
            try: bpy.data.objects.remove(duplicate, True)
            except: pass

def create_solidify_modifier(object, thickness, offset=-1, use_even_offset=True, use_rim_only=False, use_quality_normals=True, show_on_cage=True):
    solidify = object.modifiers.new("Solidify", "SOLIDIFY")
    solidify.thickness = thickness
    solidify.use_even_offset = use_even_offset
    solidify.use_quality_normals = use_quality_normals
    solidify.use_rim_only = use_rim_only
    solidify.show_on_cage = show_on_cage
    solidify.offset = offset


def deselect_all():
    for object in bpy.data.objects:
        object.select_set(action='DESELECT')


def set_active(object, select = False, only_select = False):
    bpy.context.scene.objects.active = object
    if only_select: deselect_all()
    if select or only_select: bpy.context.scene.objects.active.select = True


def apply_modifier(modifier):
    apply_modifiers(modifier.id_data, type=modifier.type, modifier=modifier)
